import moment from 'moment';
import uuid from 'uuid/v4';
import _ from 'lodash';

const prefix = uuid();

const modelCreator = () => {
  const name = 'task';
  const namespace = _.uniqueId(prefix);
  return {
    name,
    model: {
      namespace,
      state: {
        num: 0,
        list: [],
      },
      reducers: {
        queryCountSuccess(state, { payload: num }) {
          return {
            ...state,
            num,
          };
        },
        queryTasksSuccess(state, { payload: list }) {
          return {
            ...state,
            list,
          };
        },
      },
      effects: {
        *fetchTasks({ payload: { pst, psz, filters } }, { put }) {
          console.log('fetchTasks');
          const num = 100;
          yield put({ type: 'queryCountSuccess', payload: num });
          yield put({
            type: 'queryTasksSuccess',
            payload: _.range(0, num).map(idx => ({
              key: idx.toString(),
              pName: `流程${idx}`,
              nName: `任务${idx}`,
              state: `状态${(idx / 3 | 0) + 1}`,
              date: moment(),
              deadline: moment(),
            })),
          });
        },
      },
      subscriptions: {},
    },
  };
};

export default modelCreator;
